#include "testlib.h"

#include <vector>
#include <iostream>
#include <string>

using namespace std;

bool readAns(InStream& stream, vector<int> &t, vector<pair<int, int>> &jackets) {
	bool yes = stream.readToken("Yes|No") == "Yes";
	if (!yes) {
		return false;
	}
	int prev = -1;
	for (int i = 0; i < t.size(); ++i) {
		int cj = stream.readInt(1, jackets.size());
		if (cj == prev) {
			quitf(
				_wa,
				"Jacket %d used two times in a row at days %d and %d",
				cj, i, i+1
			);
		}
		if (t[i] < jackets[cj-1].first || t[i] > jackets[cj-1].second) {
			quitf(
				_wa,
				"Jacket %d (min_t=%d, max_t=%d) used at incorrect temperature: day %d (t=%d)",
				cj, jackets[cj-1].first, jackets[cj-1].second, i+1, t[i]
			);
		}
		prev = cj;
	}
	return true;
}

int main(int argc, char* argv[]) {
	registerTestlibCmd(argc, argv);
	int n = inf.readInt();
	int m = inf.readInt();
	vector<int> t(n);
	for (int i = 0; i < n; ++i) {
		t[i] = inf.readInt();
	}
	vector<pair<int, int>> jackets(m);
	for (int i = 0; i < m; ++i) {
		jackets[i].first = inf.readInt();
		jackets[i].second = inf.readInt();
	}

	bool out_b = readAns(ouf, t, jackets);
	bool ans_b = readAns(ans, t, jackets);
	
	if (out_b && ans_b) {
		quitf(_ok, "OK: Solution exists");
	}
	if (!out_b && !ans_b) {
		quitf(_ok, "OK: No solution");
	}
	if (!out_b && ans_b) {
		quitf(_wa, "WA: Existing solution not found");
	}
	if (out_b && !ans_b) {
		quitf(_fail, "FAIL: Participant found the solution whiles juri don't");
	}
}
