#include <cstdio>
#include <set>
#include <cassert>
#include <vector>
#include <algorithm>
#include <ctime>

using namespace std;

const int MAXN = 100100;
const int K = 3;

int cnt[MAXN];
int ids[MAXN][K];

int main() {
  clock_t start = clock();
  int n, m;
  scanf("%d%d", &n, &m);
  set<pair<int, int>> s;
  for (int i = 0; i < n; i++) {
    int a;
    scanf("%d", &a);
    s.insert({a, i});
  }
  for (int i = 0; i < m; i++) {
    int l, r;
    scanf("%d%d", &l, &r);
    auto it = s.lower_bound({l, -1});
    while (it != s.end() && it->first <= r) {
      auto nit = it;
      nit++;
      int id = it->second;
      ids[id][cnt[id]++] = i;
      if (cnt[id] == K) s.erase(it);
      it = nit;
    }
  }


  vector<int> order(n);
  for (int i = 0; i < n; i++) {
    order[i] = i;
  }

  vector<int> res;
  for (int i = 0; i < n; i++) {
    random_shuffle(ids[i], ids[i] + cnt[i]);
  }

  bool bad;
  while (clock() - start < 1.9 * CLOCKS_PER_SEC) {
    stable_sort(order.begin(), order.end(), [](int a, int b) { return cnt[a] < cnt[b];});
    res = vector<int>(n, -1);
     bad = false;
    for (int i : order) {
      for (int j = 0; j <= cnt[i]; j++) {
        if (j == cnt[i]) {
          bad = true;
          break;
        }
        bool ok = true;
        if (i && res[i-1] == ids[i][j]) ok = false;
        if (i != n - 1 && res[i+1] == ids[i][j]) ok = false;
        if (ok) {
          res[i] = ids[i][j];
          break;
        }
      }
      if (bad) break;
    }
    if (!bad) break;
    sort(order.begin(), order.end());
    reverse(order.begin(), order.end());
    for (int i = 0; i < n; i++) {
      random_shuffle(ids[i], ids[i] + cnt[i]);
    }
  }
  if (bad) {
    printf("No\n");
    return 0;
  }
  printf("Yes\n");
  for (int i = 0; i < n; i++) {
    printf("%d%c", res[i] + 1, " \n"[i == n - 1]);
  }
  return 0;
}
