#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

struct Event {
	int x;
	int ind;
	char type;
	/*/
	 * -1 : start jacket
	 *  0 : day
	 * +1 : end jacket
	/*/
	Event() {};
	Event(int _x, int _ind, char _type)
		: x(_x)
		, ind(_ind)
		, type(_type)
	{}
	bool operator<(const Event& other) const {
		if (x != other.x) return x < other.x;
		return type < other.type;
	}
};


int main() {
	int n, m;
	cin >> n >> m;
	vector<int> t(n);
	for (int& it : t) cin >> it;
	vector<pair<int, int>> a(m);
	for (auto& it : a) cin >> it.first >> it.second;

	vector<Event> events;
	events.reserve(n+2*m);
	for (int i = 0; i < n; ++i) {
		events.emplace_back(t[i], i, 0);
	}
	for (int i = 0; i < m; ++i) {
		events.emplace_back(a[i].first, i, -1);
		events.emplace_back(a[i].second, i, +1);
	}
	sort(events.begin(), events.end());

	const int FITS_LIMIT = 0;
	set<int> cur_jackets;
	vector<vector<int>> fits(n);

	for (auto& ev : events) {
		if (ev.type == 0) {
			int cnt = 0;
			for (int it : cur_jackets) {
				fits[ev.ind].push_back(it);
				++cnt;
				if (cnt == FITS_LIMIT) break;
			}
		} else if (ev.type == -1) {
			cur_jackets.insert(ev.ind);
		} else {
			cur_jackets.erase(ev.ind);
		}
	}

	vector<vector<int>> dp(n);

	for (int i = 0; i < fits[0].size(); ++i) {
		dp[0].push_back(0);
	}

	for (int i = 1; i < n; ++i) {
		for (int j = 0; j < fits[i].size(); ++j) {
			dp[i].push_back(-1);
			for (int k = 0; k < fits[i-1].size(); ++k) {
				if (dp[i-1][k] != -1 && fits[i][j] != fits[i-1][k]) {
					dp[i][j] = k;
				}
			}
		}
	}

	for (int i = 0; i < dp[n-1].size(); ++i) {
		if (dp[n-1][i] == -1) continue;
		cout << "Yes" << endl;
		vector<int> ans(n);
		int cur = i;
		for (int pos = n-1; pos >= 0; --pos) {
			ans[pos] = fits[pos][cur];
			cur = dp[pos][cur];
		}
		for (int it : ans) {
			cout << it+1 << " ";
		}
		cout << endl;
		return 0;
	}
	cout << "No" << endl;
}
